//----------------------------------------------------------------------------
// aniicon.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: aniicon.pas
//----------------------------------------------------------------------------
#ifndef aniiconHPP
#define aniiconHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Messages.hpp>
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <Graphics.hpp>
#include <System.hpp>
namespace Aniicon
{
//-- type declarations -------------------------------------------------------
typedef Byte ticonfile[766];

struct rtag
{
	char ckid[4];
	long cksize;
} ;

struct tAniHeader
{
	long cbSizeof;
	long cFrames;
	long cSteps;
	long cx;
	long cy;
	long cBitCount;
	long cPlanes;
	long jifRate;
	long fl;
} ;

struct ticondir
{
	Word reserved;
	Word cursortype;
	Word count;
} ;

struct ticonentry
{
	Byte width;
	Byte height;
	Byte colors;
	Byte rsrvd;
	Word hotspotx;
	Word hotspoty;
	long bytesinres;
	long imgoffset;
} ;

typedef long txormap[128];

typedef long tandmap[32];

typedef long tjifrates[128];

typedef long tsequences[128];

class __declspec(delphiclass) TAniIconFile;
class __declspec(pascalimplementation) TAniIconFile : public Graphics::TGraphic
{
	typedef Graphics::TGraphic inherited;
	
private:
	HICON iconhandles[64];
	long jifrates[128];
	long sequences[128];
	tAniHeader aniheader;
	Classes::TMemoryStream* anistream;
	bool FHasData;
	int FCurFrame;
	int FJifCount;
	Classes::TNotifyEvent FOnChange;
	void __fastcall AniDecode(void);
	
protected:
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect);
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	void __fastcall Step(void);
	void __fastcall SetFrame(int i);
	int __fastcall GetStreamSize(void);
	void __fastcall StreamToTemp( System::AnsiString filename);
	
public:
	__fastcall TAniIconFile(void);
	__fastcall virtual ~TAniIconFile(void);
	HIDESBASE void __fastcall Assign(TAniIconFile* Source);
	HIDESBASE void __fastcall LoadFromFile(const System::AnsiString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool HasData = {read=FHasData, write=FHasData, nodefault};
	int __fastcall GetCursorHandle(void);
};

class __declspec(delphiclass) TAniIcon;
class __declspec(pascalimplementation) TAniIcon : public Controls::TCustomControl
{
	typedef Controls::TCustomControl inherited;
	
private:
	TAniIconFile* FAniFile;
	bool FAnimated;
	bool FTimerRun;
	int FTimerID;
	int FFrame;
	bool FTransparent;
	bool FAnimateOnEnter;
	bool FCenter;
	bool FButtonStyle;
	bool FHasMouse;
	bool FDragging;
	void __fastcall SeTAniIconFile(TAniIconFile* newValue);
	void __fastcall SetAnimated(bool SetOn);
	void __fastcall SetFrame(int f);
	void __fastcall SetCenter(const bool value);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	
protected:
	virtual void __fastcall Paint(void);
	HIDESBASE MESSAGE void __fastcall WMEraseBkGnd(Messages::TMessage &Message);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Msg);
	HIDESBASE MESSAGE void __fastcall WMDestroy(Messages::TMessage &Message);
	void __fastcall AniChanged(System::TObject* Sender);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	
public:
	__fastcall virtual TAniIcon(Classes::TComponent* AOwner);
	__fastcall virtual ~TAniIcon(void);
	__property Canvas ;
	
__published:
	__property TAniIconFile* AniFile = {read=FAniFile, write=SeTAniIconFile, nodefault};
	__property bool Animated = {read=FAnimated, write=SetAnimated, nodefault};
	__property bool AnimateOnEnter = {read=FAnimateOnEnter, write=FAnimateOnEnter, nodefault};
	__property Align ;
	__property Color ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property int Frame = {read=FFrame, write=SetFrame, nodefault};
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property bool Transparent = {read=FTransparent, write=FTransparent, nodefault};
	__property bool Center = {read=FCenter, write=SetCenter, nodefault};
	__property bool ButtonStyle = {read=FButtonStyle, write=FButtonStyle, nodefault};
public:
	/* TWinControl.CreateParented */ __fastcall TAniIcon(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern char cklist[4];
extern char ckicon[4];
extern char ckrate[4];
extern char ckseq[4];
#define crMyAniCursor (Word)(2000)

}	/* namespace Aniicon */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Aniicon;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// aniicon
