// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'aniicon.pas' rev: 4.00

#ifndef aniiconHPP
#define aniiconHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Menus.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Aniicon
{
//-- type declarations -------------------------------------------------------
typedef Byte ticonfile[766];

#pragma pack(push, 4)
struct rtag
{
	char ckid[4];
	int cksize;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct tAniHeader
{
	int cbSizeof;
	int cFrames;
	int cSteps;
	int cx;
	int cy;
	int cBitCount;
	int cPlanes;
	int jifRate;
	int fl;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct ticondir
{
	Word reserved;
	Word cursortype;
	Word count;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct ticonentry
{
	Byte width;
	Byte height;
	Byte colors;
	Byte rsrvd;
	Word hotspotx;
	Word hotspoty;
	int bytesinres;
	int imgoffset;
} ;
#pragma pack(pop)

typedef int txormap[128];

typedef int tandmap[32];

typedef int tjifrates[128];

typedef int tsequences[128];

class DELPHICLASS TAniIconFile;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TAniIconFile : public Graphics::TGraphic 
{
	typedef Graphics::TGraphic inherited;
	
private:
	HICON iconhandles[64];
	int jifrates[128];
	int sequences[128];
	tAniHeader aniheader;
	Classes::TMemoryStream* anistream;
	bool FHasData;
	int FCurFrame;
	int FJifCount;
	Classes::TNotifyEvent FOnChange;
	void __fastcall AniDecode(void);
	
protected:
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect);
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	void __fastcall Step(void);
	void __fastcall SetFrame(int i);
	int __fastcall GetStreamSize(void);
	void __fastcall StreamToTemp(AnsiString filename);
	
public:
	__fastcall TAniIconFile(void);
	__fastcall virtual ~TAniIconFile(void);
	HIDESBASE void __fastcall Assign(TAniIconFile* Source);
	HIDESBASE void __fastcall LoadFromFile(const AnsiString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool HasData = {read=FHasData, write=FHasData, nodefault};
	unsigned __fastcall GetCursorHandle(void);
};

#pragma pack(pop)

class DELPHICLASS TAniIcon;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TAniIcon : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	TAniIconFile* FAniFile;
	bool FAnimated;
	bool FTimerRun;
	int FTimerID;
	int FFrame;
	bool FTransparent;
	bool FAnimateOnEnter;
	bool FCenter;
	bool FButtonStyle;
	bool FHasMouse;
	bool FDragging;
	void __fastcall SeTAniIconFile(TAniIconFile* newValue);
	void __fastcall SetAnimated(bool SetOn);
	void __fastcall SetFrame(int f);
	void __fastcall SetCenter(const bool value);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	
protected:
	virtual void __fastcall Paint(void);
	HIDESBASE MESSAGE void __fastcall WMEraseBkGnd(Messages::TMessage &Message);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Msg);
	HIDESBASE MESSAGE void __fastcall WMDestroy(Messages::TMessage &Message);
	void __fastcall AniChanged(System::TObject* Sender);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	
public:
	__fastcall virtual TAniIcon(Classes::TComponent* AOwner);
	__fastcall virtual ~TAniIcon(void);
	__property Canvas ;
	
__published:
	__property TAniIconFile* AniFile = {read=FAniFile, write=SeTAniIconFile};
	__property bool Animated = {read=FAnimated, write=SetAnimated, nodefault};
	__property bool AnimateOnEnter = {read=FAnimateOnEnter, write=FAnimateOnEnter, nodefault};
	__property Align ;
	__property Color ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property int Frame = {read=FFrame, write=SetFrame, nodefault};
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property bool Transparent = {read=FTransparent, write=FTransparent, nodefault};
	__property bool Center = {read=FCenter, write=SetCenter, nodefault};
	__property bool ButtonStyle = {read=FButtonStyle, write=FButtonStyle, nodefault};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TAniIcon(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE char cklist[4];
extern PACKAGE char ckicon[4];
extern PACKAGE char ckrate[4];
extern PACKAGE char ckseq[4];
static const Word crMyAniCursor = 0x7d0;

}	/* namespace Aniicon */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Aniicon;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// aniicon
